﻿package {
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.utils.getTimer;
	import lol.data.ChargeImgBinaire;
	import lol.event.ChargeImgBinaireEvent;
	
	
	[SWF(width = "800", height = "600", backgroundColor = "#454338", frameRate = "60")]
	
	/**
	 * chargement des données binaires représentant des images (gif/jpg/png/swf) d'un script PHP qui
	 * place les données dans un ordre précis :
	 * -nombre d'images (apparait qu'une seule fois)
	 * -poids de l'image
	 * -données de l'image
	 * 
	 * 
	 * conversion en DisplayObject.
	 * Ajout des DisplayObject sur la scene.
	 * 
	 * @author Lorenzo
	 */
	public class ChargementBinaire extends Sprite {
		
		private var _totalImg:uint = 0;
		private var _tbImg:Array = new Array();
		private var _posX:uint = 0;
		private var _posY:uint = 0;
		private var _time:int = 0;
		private var _php:String = "http://localhost/_progFlash/_flashdevelop/ChargementImgBinaireParURLLoader/bin/php/imgBinaire.php?x=" + Math.random();
		private var _temps:uint = 0;
		
		
		
		public function ChargementBinaire():void {
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void {
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			stage.scaleMode = "noScale";
			stage.align = "TL";
			
			var chargeur:ChargeImgBinaire = new ChargeImgBinaire();
			chargeur.addEventListener(ChargeImgBinaireEvent.PROGRES, evtBinaireProgres);
			chargeur.addEventListener(ChargeImgBinaireEvent.ERREUR_CHARGEMENT, evtBinaireErreurChargement);
			chargeur.addEventListener(ChargeImgBinaireEvent.ERREUR_CONVERSION, evtBinaireErreurConversion);
			chargeur.addEventListener(ChargeImgBinaireEvent.FIN, evtBinaireFin);
			_temps = getTimer();
			chargeur.lancer(_php);
			
			stage.addEventListener(Event.RESIZE, evtStageResize);
		}


		// -----------------------------------------------------------------------------------
		// EVENEMENTS
		// -----------------------------------------------------------------------------------
		
		private function evtBinaireProgres(ev:ChargeImgBinaireEvent):void {
			trace("evtBinaireProgres : ", ev.pourcent);
		}
		
		private function evtBinaireErreurChargement(ev:ChargeImgBinaireEvent):void {
			trace("evtBinaireErreurChargement : ", ev.text);
		}
		
		private function evtBinaireErreurConversion(ev:ChargeImgBinaireEvent):void {
			trace("evtBinaireErreurConversion : ", ev.text);
		}
		
		private function evtBinaireFin(ev:ChargeImgBinaireEvent):void {
			var chargeur:ChargeImgBinaire = ev.currentTarget as ChargeImgBinaire;
			trace("evtBinaireFin", chargeur.images.length, chargeur.totalImg);
			trace(getTimer() - _temps);
			if ( chargeur.images.length ) {
				while (this.numChildren > 0 ) {
					this.removeChildAt(0);
				}
				_posX = 0;
				_posY = 0;
				for (var i:int = 0; i < chargeur.images.length; i++) {
					var dob:DisplayObject = chargeur.images[i] as DisplayObject;
					dob.x = _posX;
					dob.y = _posY;
					this.addChild(dob);
					_posX += dob.width;
					if ( (_posX + dob.width) > stage.stageWidth ) {
						_posX = 0;
						_posY += dob.height;
					}
				}
				_totalImg = chargeur.images.length;
				_tbImg = chargeur.images;
			}
		}

		
		
		private function evtStageResize(e:Event):void {
			if ( _tbImg.length && _totalImg == _tbImg.length ) {
				while (this.numChildren > 0 ) {
					this.removeChildAt(0);
				}
				_posX = 0;
				_posY = 0;
				for (var i:int = 0; i < _totalImg; i++) {
					var dob:DisplayObject = _tbImg[i] as DisplayObject;
					dob.x = _posX;
					dob.y = _posY;
					this.addChild(dob);
					_posX += dob.width;
					if ( (_posX + dob.width) > stage.stageWidth ) {
						_posX = 0;
						_posY += dob.height;
					}
				}
			}
		}
	}
	
}