﻿/* ----------------------------------------------------------------------------
*
* 
*                            classe ChargeImgBinaireEvent v1.0
*
*
* Flash >= AS3
* ©Lorenzo le 03/08/2010
* 
 ------------------------------------------------------------------------------- */
package lol.event {
	
	import flash.events.Event;




	/**
	* Gestion des évenements de la classe ChargeImgBinaire.
	* @see lol.data.ChargeImgBinaire
	*/
	public class ChargeImgBinaireEvent extends Event{
		

		// ---------------------------------------------------------------------------------------------
		// Propriétés
		// ---------------------------------------------------------------------------------------------
		
		/**
		 * Le texte d'erreur renvoyé par :
		 * ChargeImgBinaireEvent.ERREUR_CONVERSION
		 * ChargeImgBinaireEvent.ERREUR_CONVERSION_FATAL
		 * ChargeImgBinaireEvent.ERREUR_CHARGEMENT
		 */
		public var text:String = "";
		
		/**
		 * Le pourcentage de progression renvoyé par ChargeImgBinaireEvent.PROGRES
		 */
		public var pourcent:Number = 0;

		
		// ---------------------------------------------------------------------------------------------
		// Évenements
		// ---------------------------------------------------------------------------------------------
		
		/**
		 * Evenement executé pendant la progression du chargement.
		 * @eventType lol.event.ChargeImgBinaireEvent.PROGRES
		 */
		public static const PROGRES:String = "progres";
		
		/**
		 * Evenement executé lors d'une erreur de conversion.
		 * @eventType lol.event.ChargeImgBinaireEvent.ERREUR_CONVERSION
		 */
		public static const ERREUR_CONVERSION:String = "erreurConversion";
		
		/**
		 * Evenement executé lors d'une erreur de conversion (coupe le script).
		 * @eventType lol.event.ChargeImgBinaireEvent.ERREUR_CONVERSION_FATAL
		 */
		public static const ERREUR_CONVERSION_FATAL:String = "erreurConversionFatal";
		
		/**
		 * Evenement executé lors d'une erreur de chargement du fichier.
		 * @eventType lol.event.ChargeImgBinaireEvent.ERREUR_CHARGEMENT
		 */
		public static const ERREUR_CHARGEMENT:String = "erreurChargement";
		
		/**
		 * Evenement executé lorsque le chargement + conversion est fini.
		 * @eventType lol.event.ChargeImgBinaireEvent.FIN
		 */
		public static const FIN:String = "fin";
		




		// ---------------------------------------------------------------------------------------------
		// Consructeur
		// ---------------------------------------------------------------------------------------------

		/**
		 * Constructeur
		 * 
		 * @param type Le type de l'evenement
		 * @param bubbles Indique si un événement peut se propager vers le haut (bubbling).
		 * @param cancelable Indique si le comportement associé à l’événement peut être annulé.
		 * @param pourcent Le pourcentage de progression renvoyé par ChargeImgBinaireEvent.PROGRES
		 * @param text Le texte d'erreur renvoyé par :
		 * ChargeImgBinaireEvent.ERREUR_CHARGEMENT
		 * ChargeImgBinaireEvent.ERREUR_CONVERSION
		 * ChargeImgBinaireEvent.ERREUR_CONVERSION_FATAL
		 * 
		 * @return void
		 */
		public function ChargeImgBinaireEvent(type:String, bubbles:Boolean=false, cancelable:Boolean=false, pourcent:Number = 0, text:String = ""){
			super(type, bubbles, cancelable);
			this.pourcent = pourcent;
			this.text = text;
		}
		




		// ---------------------------------------------------------------------------------------------
		// Méthodes
		// ---------------------------------------------------------------------------------------------

		/**
		 * Clone
		 * 
		 * @return Event
		 */
		override public function clone():Event{
			return new ChargeImgBinaireEvent(this.type, this.bubbles, this.cancelable, this.pourcent, this.text);
		}

		/**
		 * toString
		 * 
		 * @return String
		 */
		override public function toString():String{
			return formatToString("ChargeImgBinaireEvent", "type", "bubbles", "cancelable", "eventPhase");
		}
	}
}